#include <stdio.h>
#include <stdlib.h>
#include <sched.h>
#include <string.h>
#include <errno.h>
#include <math.h>
#include <asm/msr.h>
#include <sys/mman.h>

int main(int argc, char **argv)
{
    struct sched_param param;
    unsigned long t1, t2, tsccost;
    double f;
    int i;

    if (mlockall(MCL_CURRENT | MCL_FUTURE)) {
        fprintf(stderr, "%s: mlockall: %s\n", argv[0], strerror(errno));
        /* continue anyway */
    }
    if (!getenv("BENCH_NOTRT")) {
	param.sched_priority = 1;
	if (sched_setscheduler(0, SCHED_RR, &param)<0) {
	    fprintf(stderr,"%s: setscheduler: %s\n", argv[0], strerror(errno));
	    /* continue anyway */
	}
    }


    rdtscl(t1); /* read time stamp counter    */
    rdtscl(t2); /* as a "long" (32 bit) value */
    tsccost = t2 - t1;

    for (i=0; i<10; i++) {
    rdtscl(t1); /* time stamp counter, 32 bits */
    f = sin(1.0);
    rdtscl(t2);
    printf("sin(1) takes %5li cycles\n", t2 - t1 - tsccost);

    rdtscl(t1); /* time stamp counter, 32 bits */
    f = tan(1.0);
    rdtscl(t2);
    printf("tan(1) takes %5li cycles\n", t2 - t1 - tsccost);

    rdtscl(t1); /* time stamp counter, 32 bits */
    f = sin(0.0);
    rdtscl(t2);
    printf("sin(0) takes %5li cycles\n", t2 - t1 - tsccost);
    }
    return 0;
}
/* per compilare: "make trig-rep LDFLAGS=-lm" */
